import {ModelComponentCreator} from "./ModelComponentCreator";
import {ModelComponent} from "../../ModelComponent";
import {GameModel} from "../../GameModel";
import {AbstractItemGroup} from "../../inventory/AbstractItemGroup";
import {ModelComponentType} from "../../ModelComponentType";
import {ConcreteItemGroup} from "../../inventory/ConcreteItemGroup";

export class ItemgroupCreator extends ModelComponentCreator {



  constructor(context: string, gameModel: GameModel, selectedComponent: ModelComponent | undefined) {
    super(context, gameModel, selectedComponent);
  }

  createModelComponent(): ModelComponent | undefined{
    let itemgroup;
    if(this.context === 'abstract') {
      itemgroup = new AbstractItemGroup("New Abstract Itemgroup", "", ModelComponentType.ITEMGROUP);
    } else if(this.context === 'concrete') {
      itemgroup = new ConcreteItemGroup("New Concrete Itemgroup", "", ModelComponentType.ITEMGROUP);
    } else {
      return undefined
    }

    if(this.selectedComponent != null && this.selectedComponent instanceof AbstractItemGroup) {
      this.selectedComponent.addChildItemgroup(itemgroup);
    } else {
      this.gameModel.itemgroups.push(itemgroup);
    }

    return itemgroup;
  }


}
