import {ScriptAccount} from "../../game-model/scriptAccounts/ScriptAccount";
import {ScriptAccountCondition} from "../../game-model/gamesystems/conditions/ScriptAccountCondition";
import {ScriptAccountAction} from "../../game-model/gamesystems/actions/ScriptAccountAction";

export class ScriptAccountActionParser {
  private scriptAccounts: ScriptAccount[]


  constructor(scriptAccounts: ScriptAccount[]) {
    this.scriptAccounts = scriptAccounts;
  }

  parseActions(actionData: any) {
    const actions: ScriptAccountAction[]  = []
    for(let i=0; i<actionData.length; i++) {
      const parsedCondition = this.parseSingleAction(actionData[i]);
      if(parsedCondition != undefined) {
        actions.push(parsedCondition)
      }
    }
    return actions
  }

  private parseSingleAction(actionData: any) {
    const referencedScriptAccount = this.findScriptAccountByName(actionData.scriptAccount);
    if(referencedScriptAccount != undefined) {
      return new ScriptAccountAction(referencedScriptAccount, actionData.changingValue);
    } else {
      return undefined;
    }
  }

  private findScriptAccountByName(scriptAccountName: string) {
    return this.scriptAccounts.find(scriptAccount => scriptAccount.componentName === scriptAccountName);
  }
}
